/*-
 * Copyright (C) @BABOLO  2005 Oct 14
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: expo.cc,v 1.1 2005/11/12 21:12:29 babolo Exp $
 */

/*    */
static const ISO8583_Package ISO8583_ExpoBankQPackage = {
 1, 0, 65, 0, 0x8000000000000000L, 0L
,{{ISO8583_B_NUMERIC  ,   4, "Message Type Indicator"}                     /*00*/
 ,{ISO8583_B_LITERAL  ,   8, "Bitmap"}                                     /*01*/
 ,{ISO8583_B_LLNUMl   ,  19, "PAN - Primary Account number"}               /*02*/
 ,{ISO8583_B_NUMERIC  ,   6, "Processing Code"}                            /*03*/
 ,{ISO8583_B_NUMERIC  ,  12, "Amount, Transaction"}                        /*04*/
 ,{ISO8583_B_NUMERIC  ,  12, "?Amount, Reconciliation"}                    /*05*/
 ,{ISO8583_B_NUMERIC  ,  12, "?Amount, Cardholder billing"}                /*06*/
 ,{ISO8583_B_TIME     ,  10, "Date and time, transmission"}                /*07*/
 ,{ISO8583_B_NUMERIC  ,   8, "?Amount, Cardholder billing fee"}            /*08*/
 ,{ISO8583_B_NUMERIC  ,   8, "?Conversion rate, Reconciliation"}           /*09*/
 ,{ISO8583_B_NUMERIC  ,   8, "?Conversion rate, Cardholder billing"}       /*10*/
 ,{ISO8583_B_NUMERIC  ,   6, "Systems trace audit number"}                 /*11*/
 ,{ISO8583_B_TIME     ,   6, "Time, Local transaction"}                    /*12*/
 ,{ISO8583_B_DATET    ,   4, "Date, Local transaction"}                    /*13*/
 ,{ISO8583_B_DATE     ,   4, "Date, Expiration"}                           /*14*/
 ,{ISO8583_B_DATE     ,   6, "?Date, Settlement"}                          /*15*/
 ,{ISO8583_B_DATE     ,   4, "?Date, Conversion"}                          /*16*/
 ,{ISO8583_B_DATE     ,   4, "?Date, Capture"}                             /*17*/
 ,{ISO8583_B_NUMERIC  ,   4, "?Merchant type"}                             /*18*/
 ,{ISO8583_B_NUMERIC  ,   3, "Country code, Acquiring institution"}        /*19*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Country code, Primary account number"}      /*20*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Country code, Forwarding institution"}      /*21*/
 ,{ISO8583_B_NUMERIC  ,   3, "POS Entry Mode"}                             /*22*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Card sequence number"}                      /*23*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Function code"}                             /*24*/
 ,{ISO8583_B_NUMERIC  ,   2, "POS Condition Code"}                         /*25*/
 ,{ISO8583_B_NUMERIC  ,   4, "?Card acceptor business code"}               /*26*/
 ,{ISO8583_B_NUMERIC  ,   1, "?Approval code length"}                      /*27*/
 ,{ISO8583_B_NUMERIC  ,   6, "?Date, Reconciliation"}                      /*28*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Reconciliation indicator"}                  /*29*/
 ,{ISO8583_B_NUMERIC  ,  24, "?Amounts, original"}                         /*30*/
 ,{ISO8583_B_LLCHAR   ,  99, "?Acquirer reference data"}                   /*31*/
 ,{ISO8583_B_LLNUM    ,  11, "Acquirer institution ident code"}            /*32*/
 ,{ISO8583_B_LLNUM    ,  11, "?Forwarding institution ident code"}         /*33*/
 ,{ISO8583_B_LLCHAR   ,  28, "?Primary account number, extended"}          /*34*/
 ,{ISO8583_B_LLCHAR   ,  37, "Track 2 data"}                               /*35*/
 ,{ISO8583_B_LLLCHAR  , 104, "?Track 3 data"}                              /*36*/
 ,{ISO8583_B_NUMERIC  ,  12, "Retrieval reference number"}                 /*37*/
 ,{ISO8583_I_CHAR     ,   6, "Authorization Identification Response"}      /*38*/
 ,{ISO8583_I_CHAR     ,   2, "Response Code"}                              /*39*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Service code"}                              /*40*/
 ,{ISO8583_I_CHAR     ,   8, "Card acceptor terminal identification"}      /*41*/
 ,{ISO8583_I_CHAR     ,  15, "?Card acceptor identification code"}         /*42*/
 ,{ISO8583_B_LLCHAR   ,  99, "?Card acceptor name/location"}               /*43*/
 ,{ISO8583_B_LLCHAR   ,  99, "?Additional response data"}                  /*44*/
 ,{ISO8583_B_LLCHAR   ,  76, "?Track 1 data"}                              /*45*/
 ,{ISO8583_B_LLLCHAR  , 204, "?Amounts, Fees"}                             /*46*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Additional data - national"}                /*47*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Additional data - private"}                 /*48*/
 ,{ISO8583_B_NUMERIC  ,   3, "Currency code, Transaction"}                 /*49*/
 ,{ISO8583_I_CHAR     ,   3, "?Currency code, Reconciliation"}             /*50*/
 ,{ISO8583_I_CHAR     ,   3, "?Currency code, Cardholder billing"}         /*51*/
 ,{ISO8583_B_BINARY   ,   8, "?Personal identification number (PIN) data"} /*52*/
 ,{ISO8583_B_LLBINARY ,  48, "?Security related control information"}      /*53*/
 ,{ISO8583_B_LLLCHAR  , 120, "?Amounts, additional"}                       /*54*/
 ,{ISO8583_B_LLLBINARY, 255, "?IC card system related data"}               /*55*/
 ,{ISO8583_B_LLNUM    ,  35, "?Original data elements"}                    /*56*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Authorization life cycle code"}             /*57*/
 ,{ISO8583_B_LLNUM    ,  11, "?Authorizing agent institution Id Code"}     /*58*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Transport data"}                            /*59*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Reserved for national use"}                 /*60*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Reserved for national use"}                 /*61*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Reserved for private use"}                  /*62*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Reserved for private use"}                  /*63*/
 ,{ISO8583_B_BINARY   ,   8, "?Message authentication code field"}         /*64*/
}};

/*    */
static const ISO8583_Package ISO8583_ExpoBankAPackage = {
 1, 0, 65, 0, 0x8000000000000000L, 0L
,{{ISO8583_B_NUMERIC  ,   4, "Message Type Indicator"}                     /*00*/
 ,{ISO8583_B_LITERAL  ,   8, "Bitmap"}                                     /*01*/
 ,{ISO8583_B_LLNUM    ,  19, "PAN - Primary Account number"}               /*02*/
 ,{ISO8583_B_NUMERIC  ,   6, "Processing Code"}                            /*03*/
 ,{ISO8583_B_NUMERIC  ,  12, "Amount, Transaction"}                        /*04*/
 ,{ISO8583_B_NUMERIC  ,  12, "?Amount, Reconciliation"}                    /*05*/
 ,{ISO8583_B_NUMERIC  ,  12, "?Amount, Cardholder billing"}                /*06*/
 ,{ISO8583_B_TIME     ,  10, "Date and time, transmission"}                /*07*/
 ,{ISO8583_B_NUMERIC  ,   8, "?Amount, Cardholder billing fee"}            /*08*/
 ,{ISO8583_B_NUMERIC  ,   8, "?Conversion rate, Reconciliation"}           /*09*/
 ,{ISO8583_B_NUMERIC  ,   8, "?Conversion rate, Cardholder billing"}       /*10*/
 ,{ISO8583_B_NUMERIC  ,   6, "Systems trace audit number"}                 /*11*/
 ,{ISO8583_B_TIME     ,   6, "Time, Local transaction"}                    /*12*/
 ,{ISO8583_B_DATET    ,   4, "Date, Local transaction"}                    /*13*/
 ,{ISO8583_B_DATE     ,   4, "Date, Expiration"}                           /*14*/
 ,{ISO8583_B_DATE     ,   6, "?Date, Settlement"}                          /*15*/
 ,{ISO8583_B_DATE     ,   4, "?Date, Conversion"}                          /*16*/
 ,{ISO8583_B_DATE     ,   4, "?Date, Capture"}                             /*17*/
 ,{ISO8583_B_NUMERIC  ,   4, "?Merchant type"}                             /*18*/
 ,{ISO8583_B_NUMERIC  ,   3, "Country code, Acquiring institution"}        /*19*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Country code, Primary account number"}      /*20*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Country code, Forwarding institution"}      /*21*/
 ,{ISO8583_B_NUMERIC  ,   3, "POS Entry Mode"}                             /*22*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Card sequence number"}                      /*23*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Function code"}                             /*24*/
 ,{ISO8583_B_NUMERIC  ,   2, "POS Condition Code"}                         /*25*/
 ,{ISO8583_B_NUMERIC  ,   4, "?Card acceptor business code"}               /*26*/
 ,{ISO8583_B_NUMERIC  ,   1, "?Approval code length"}                      /*27*/
 ,{ISO8583_B_NUMERIC  ,   6, "?Date, Reconciliation"}                      /*28*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Reconciliation indicator"}                  /*29*/
 ,{ISO8583_B_NUMERIC  ,  24, "?Amounts, original"}                         /*30*/
 ,{ISO8583_B_LLCHAR   ,  99, "?Acquirer reference data"}                   /*31*/
 ,{ISO8583_B_LLNUM    ,  11, "Acquirer institution ident code"}            /*32*/
 ,{ISO8583_B_LLNUM    ,  11, "?Forwarding institution ident code"}         /*33*/
 ,{ISO8583_B_LLCHAR   ,  28, "?Primary account number, extended"}          /*34*/
 ,{ISO8583_B_LLCHAR   ,  37, "Track 2 data"}                               /*35*/
 ,{ISO8583_B_LLLCHAR  , 104, "?Track 3 data"}                              /*36*/
 ,{ISO8583_B_NUMERIC  ,  12, "Retrieval reference number"}                 /*37*/
 ,{ISO8583_I_CHAR     ,   6, "Authorization Identification Response"}      /*38*/
 ,{ISO8583_I_CHAR     ,   2, "Response Code"}                              /*39*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Service code"}                              /*40*/
 ,{ISO8583_I_CHAR     ,   8, "Card acceptor terminal identification"}      /*41*/
 ,{ISO8583_I_CHAR     ,  15, "?Card acceptor identification code"}         /*42*/
 ,{ISO8583_B_LLCHAR   ,  99, "?Card acceptor name/location"}               /*43*/
 ,{ISO8583_B_LLCHAR   ,  99, "?Additional response data"}                  /*44*/
 ,{ISO8583_B_LLCHAR   ,  76, "?Track 1 data"}                              /*45*/
 ,{ISO8583_B_LLLCHAR  , 204, "?Amounts, Fees"}                             /*46*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Additional data - national"}                /*47*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Additional data - private"}                 /*48*/
 ,{ISO8583_B_NUMERIC  ,   3, "Currency code, Transaction"}                 /*49*/
 ,{ISO8583_I_CHAR     ,   3, "?Currency code, Reconciliation"}             /*50*/
 ,{ISO8583_I_CHAR     ,   3, "?Currency code, Cardholder billing"}         /*51*/
 ,{ISO8583_B_BINARY   ,   8, "?Personal identification number (PIN) data"} /*52*/
 ,{ISO8583_B_LLBINARY ,  48, "?Security related control information"}      /*53*/
 ,{ISO8583_B_LLLCHAR  , 120, "?Amounts, additional"}                       /*54*/
 ,{ISO8583_B_LLLBINARY, 255, "?IC card system related data"}               /*55*/
 ,{ISO8583_B_LLNUM    ,  35, "?Original data elements"}                    /*56*/
 ,{ISO8583_B_NUMERIC  ,   3, "?Authorization life cycle code"}             /*57*/
 ,{ISO8583_B_LLNUM    ,  11, "?Authorizing agent institution Id Code"}     /*58*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Transport data"}                            /*59*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Reserved for national use"}                 /*60*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Reserved for national use"}                 /*61*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Reserved for private use"}                  /*62*/
 ,{ISO8583_B_LLLCHAR  , 999, "?Reserved for private use"}                  /*63*/
 ,{ISO8583_B_BINARY   ,   8, "?Message authentication code field"}         /*64*/
}};
